// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Globalization;
using Hiperscan.ApoIdentCore.SectionManager.FieldDefinitions;
using Hiperscan.Unix;

namespace Hiperscan.ApoIdentCore.SectionManager.Specimen.Fields
{
    public class PriceField : InputField<string>
    {
        public PriceField()
        {
            this.Init();
        }

        public override void SetDefaultValue()
        {
            this.Entry = String.Empty;
        }

        protected override bool CheckEntry()
        {
            if (String.IsNullOrEmpty(this.entry) == true)
                return true;

            return Double.TryParse(this.entry, System.Globalization.NumberStyles.AllowDecimalPoint, CultureInfo.CurrentCulture, out _);
        }

        protected override bool Compare(string value1, string value2)
        {
            return value1 == value2;
        }

        public override string GetEntryValue()
        {
            return this.entry;
        }

        public string Currency { get; set; }
        public override string ErrorMessage => Catalog.GetString("The field can be empty or the value must be a floating point number.");
        public override int FieldLength => 7;
    }
}
